#!/usr/bin/python3

import ltspy3
from pylab import *
import os

#edit to call ltspice with tb_pyctrl.asc on your system
os.system("wine c:/Program\ Files/LTC/LTspiceXVII/XVIIx64.exe -b -Run tb_pyctrl.asc 2>/dev/null")

sd=ltspy3.SimData("tb_pyctrl.raw")

ivo=sd.variables.index(b"V(vo)")
dcgain=abs(sd.values[ivo][0])
bwgain=dcgain/sqrt(2)
nbw=0
while(abs(sd.values[ivo][nbw])>bwgain):
    nbw+=1
fbw=abs(sd.values[0][nbw])

loglog(abs(sd.values[0]),abs(sd.values[ivo]))
xlabel("frequency/Hz")
ylabel("gain")
annotate("BW=%.0fHz" % fbw,
         xy=(abs(sd.values[0][nbw]),abs(sd.values[ivo][nbw])),
         xytext=(abs(sd.values[0][nbw])*10,abs(sd.values[ivo][nbw])),
         arrowprops=dict(arrowstyle='->'))

show()
